
#property copyright ""
#property link      ""

#property indicator_chart_window

extern color kolor_pips=Black;
extern color kolor_sl=Red;
extern color kolor_zysk=Green;
extern bool wszystkie_pary=false;

int init() {
   ObjectCreate("lpm_pips",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_pips",OBJPROP_CORNER,2);
   ObjectSetText("lpm_pips","pips",30);
   ObjectSet("lpm_pips",OBJPROP_COLOR,kolor_pips);
   ObjectSet("lpm_pips",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_pips",OBJPROP_YDISTANCE,20);
   
   ObjectCreate("lpm_pips_tosl",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_pips_tosl",OBJPROP_CORNER,2);
   ObjectSetText("lpm_pips_tosl","S",11);
   ObjectSet("lpm_pips_tosl",OBJPROP_COLOR,kolor_sl);
   ObjectSet("lpm_pips_tosl",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_pips_tosl",OBJPROP_YDISTANCE,5);

   ObjectCreate("lpm_pips_realized",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_pips_realized",OBJPROP_CORNER,2);
   ObjectSetText("lpm_pips_realized","R",11);
   ObjectSet("lpm_pips_realized",OBJPROP_COLOR,kolor_zysk);
   ObjectSet("lpm_pips_realized",OBJPROP_XDISTANCE,50);
   ObjectSet("lpm_pips_realized",OBJPROP_YDISTANCE,5); 

/*   ObjectCreate("lpm_longlabel",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_longlabel",OBJPROP_CORNER,2);
   ObjectSetText("lpm_longlabel","Long:",11);
   ObjectSet("lpm_longlabel",OBJPROP_COLOR,kolor_pips);
   ObjectSet("lpm_longlabel",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_longlabel",OBJPROP_YDISTANCE,90);

   ObjectCreate("lpm_shortlabel",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_shortlabel",OBJPROP_CORNER,2);
   ObjectSetText("lpm_shortlabel","Short",11);
   ObjectSet("lpm_shortlabel",OBJPROP_COLOR,kolor_sl);
   ObjectSet("lpm_shortlabel",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_shortlabel",OBJPROP_YDISTANCE,70);

   ObjectCreate("lpm_long",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_long",OBJPROP_CORNER,2);
   ObjectSetText("lpm_long","L",11);
   ObjectSet("lpm_long",OBJPROP_COLOR,kolor_sl);
   ObjectSet("lpm_long",OBJPROP_XDISTANCE,65);
   ObjectSet("lpm_long",OBJPROP_YDISTANCE,90);

   ObjectCreate("lpm_short",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_short",OBJPROP_CORNER,2);
   ObjectSetText("lpm_short","S",11);
   ObjectSet("lpm_short",OBJPROP_COLOR,kolor_sl);
   ObjectSet("lpm_short",OBJPROP_XDISTANCE,65);
   ObjectSet("lpm_short",OBJPROP_YDISTANCE,70);
*/
   start();
   
   return(0);
}

int deinit() {
   ObjectDelete("lpm_pips");
   ObjectDelete("lpm_pips_tosl");
   ObjectDelete("lpm_pips_realized");
   ObjectDelete("lpm_long");
   ObjectDelete("lpm_short");   
   ObjectDelete("lpm_longlabel");
   ObjectDelete("lpm_shortlabel");
   return(0);
}

int start() {

   ObjectSetText("lpm_short",DoubleToStr(countOrders(OP_SELL,wszystkie_pary),0));
   ObjectSetText("lpm_long",DoubleToStr(countOrders(OP_BUY,wszystkie_pary),0));
   
   double profit;
   double sl;
   calcProfit(profit,sl,wszystkie_pary);
   
   ObjectSetText("lpm_pips",sign(profit)+DoubleToStr(MathAbs(profit),0));
   ObjectSetText("lpm_pips_tosl",sign(sl)+DoubleToStr(MathAbs(sl),0));

   double realized;
   calcRealized(realized,wszystkie_pary);
   
   ObjectSetText("lpm_pips_realized",sign(realized)+DoubleToStr(MathAbs(realized),0));


   return(0);
}

void calcRealized(double& out, bool wszystkie_pary=false) {

   double profit=0;
   double p=0;   
      
   for(int i=0;i<OrdersHistoryTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) {
     
     if(wszystkie_pary || OrderSymbol()==Symbol()) {
     
      if(OrderCloseTime()<StrToTime("0:00")) {
       continue;
      }
      
      p=0;
      
      if(OrderType()==OP_BUY) {
       p=(OrderClosePrice()-OrderOpenPrice())/Point;
      }
      
      if(OrderType()==OP_SELL) {
       p=(OrderOpenPrice()-OrderClosePrice())/Point;
      }
      
      profit+=p;
     
     }
    }
   }

   out=profit;

}

double calcProfit(double& out, double& outsl,bool wszystkie_pary=false) {

   double profit=0;
   double p=0;
   double sl=0;
   double s=0;
      
   for(int i=0;i<OrdersTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS)) {
     
     if(wszystkie_pary || OrderSymbol()==Symbol()) {
      
      p=0;
      s=0;
      
      if(OrderType()==OP_BUY) {
       p=(Bid-OrderOpenPrice())/Point;
       if(OrderStopLoss()>0) {
        s=(OrderStopLoss()-OrderOpenPrice())/Point;
       }
      }
      
      if(OrderType()==OP_SELL) {
       p=(OrderOpenPrice()-Ask)/Point;
       if(OrderStopLoss()>0) {
        s=(OrderOpenPrice()-OrderStopLoss())/Point;
       }
      }
      
      sl+=s;
      profit+=p;
     
     }
    }
   }
   
   out=profit;
   outsl=sl;

}

int countOrders(int oType,bool wszystkie_pary=false) {

   int count=0;
 
   for(int i=0;i<OrdersTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS)) {
     if(wszystkie_pary || OrderSymbol()==Symbol()) {
      if(OrderType()==oType || oType<0) {
       count++;
      }
     }
    }
   }
   
   return(count);
 
}

string sign(double value) {
 
   if(value>0) {
    return("+");
   }
 
   if(value<0) {
    return("-");
   }

}