#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
//---- indicator settings
#property indicator_chart_window
#property indicator_minimum 0
#property indicator_buffers 5
#property indicator_color1  Black
#property indicator_color2  Lime
#property indicator_color3  Red
#property indicator_color4  Yellow
#property indicator_color5  Yellow
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3
//---- indicator buffers
double ExtTailsBuffer[];
double ExtTailsUpBuffer[];
double ExtTailsDownBuffer[];
double ExtTailsUpTmpBuffer[];
double ExtTailsDownTmpBuffer[];
double Range = 5;
int digit = 0,mypoint;
bool UP=false,DN=false;

bool  DN_on_closeHTR_alert = false;
bool  DN_on_closeHTC_alert = false;
bool  UP__on_closeLTR_alert = false;
bool  UP__on_closeLTC_alert = false;
  
bool  DN_on_currentHTR_alert = false;
bool  DN_on_currentHTC_alert = false;
bool  UP__on_currentLTR_alert = false;
bool  UP__on_currentLTC_alert = false;


extern double Tail_Reverse =7.5;
extern double Tail_Continuation =7.5;
// extern double Momentum__open_offset
extern bool Alerts_on_close = false;
extern bool Alerts_on_current = false;
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping

 SetIndexStyle(1, DRAW_ARROW, EMPTY,1);
   SetIndexArrow(1, 233);
   SetIndexBuffer(1, ExtTailsUpBuffer);
   SetIndexStyle(2, DRAW_ARROW, EMPTY,1);
   SetIndexArrow(2, 234);
   SetIndexBuffer(2, ExtTailsDownBuffer);
   SetIndexStyle(3, DRAW_ARROW, EMPTY,2);
   SetIndexArrow(3, 233);
   SetIndexBuffer(3, ExtTailsUpTmpBuffer);
   SetIndexStyle(4, DRAW_ARROW, EMPTY,2);
   SetIndexArrow(4, 234);
   SetIndexBuffer(4, ExtTailsDownTmpBuffer);

//---- sets default precision format for indicators visualization
   //IndicatorDigits(0);   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Momentum mrenko Tails");
   SetIndexLabel(0,"Momentum mrenko Tails");      
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
//---- sets drawing line empty value
   //SetIndexEmptyValue(1,0.0);
   //SetIndexEmptyValue(2,0.0);       
//---- initialization done

digit  = MarketInfo(Symbol(),MODE_DIGITS);
   if(MarketInfo(Symbol(), MODE_DIGITS)==3||MarketInfo(Symbol(), MODE_DIGITS)==5)
   mypoint=10;
   else mypoint=1;
   
   Tail_Reverse = Tail_Reverse*mypoint;
   Tail_Continuation = Tail_Continuation*mypoint;
   Range = Range * mypoint;
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Tails                                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i,nLimit,nCountedBars;
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//---- last counted bar will be recounted
   if(nCountedBars>0) nCountedBars--;
   nLimit=Bars-nCountedBars;
//----
  
  if (bNewBar()) {
  
  ExtTailsUpTmpBuffer[1]=0.0;
  ExtTailsDownTmpBuffer[1]=0.0; 
  
  DN_on_closeHTR_alert = true;//
  DN_on_closeHTC_alert = true;
  UP__on_closeLTR_alert = true;//
  UP__on_closeLTC_alert = true;//
  
  DN_on_currentHTR_alert = true;
  DN_on_currentHTC_alert = true;
  UP__on_currentLTR_alert = true;
  UP__on_currentLTC_alert = true;
  
  }
  
   for(i=0; i<nLimit; i++)
     {
     UP=false; DN=false;
     double dTail;
     
     //Low Tail Reverse
     if (Tail_Reverse == 0) { 
                            if(Open[i+1]-Low[i+1] > 0 && Close[i+1]-Open[i+1] >0 && Open[i+2]-Close[i+2]>0 ) 
                              {
                              dTail = (0); UP=true; DN=false;
                              } else 
                                {
                                dTail = 0;
                                }
                              }
     if (Tail_Reverse > 0) {
                           if(Open[i+1]-Low[i+1] > Tail_Reverse*Point  && Close[i+1]-Open[i+1] >0 && Open[i+2]-Close[i+2]>0 ) 
                              {
                              dTail = (Low[i+1]-Range*Point); 
                              UP=true; 
                              DN=false;
                              if (i== 1 && Alerts_on_close && UP__on_closeLTR_alert ) {UP__on_closeLTR_alert = false; Alert("Symbol "+Symbol()+" On close Low Tail Reverse"); }
                              } else 
                                {
                                dTail = 0;
                                } 
                              } 
      
     //Low Tail Continuaion
     if (Tail_Continuation == 0 && Close[i+1]-Open[i+1] >0 && Close[i+2]-Open[i+2]>0 ) 
         { if(Open[i+1]-Low[i+1] > 0 ) 
           {
           dTail = (0); UP=true; DN=false;
           } 
           else 
           {
           dTail = 0;
           }
         } 
     if (Tail_Continuation > 0 && Close[i+1]-Open[i+1] >0 && Close[i+2]-Open[i+2]>0 ) 
         { if(Open[i+1]-Low[i+1] > Tail_Continuation*Point ) 
           {
           dTail = (Low[i+1]-Range*Point); 
           UP=true ; 
           DN=false;
           if (i== 1 && Alerts_on_close && UP__on_closeLTC_alert ) {UP__on_closeLTC_alert = false; Alert("Symbol "+Symbol()+" On close Low Tail Continuation"); }
           } 
           else 
           {
           dTail = 0;
           }   
         } 
     
     
     //High Tail Reverse
     if (Tail_Reverse == 0)
        { if((High[i+1]-Open[i+1]) > 0 && Close[i+1]-Open[i+1] <0 && Close[i+2]-Open[i+2]>0) 
           {
           dTail = (0); 
           UP=false; 
           DN=true;
           }
        }
     if (Tail_Reverse > 0) 
        { if((High[i+1]-Open[i+1]) > Tail_Reverse*Point && Close[i+1]-Open[i+1] <0 && Close[i+2]-Open[i+2]>0) 
           {
           dTail = (High[i+1]+Range*Point); 
           UP=false; 
           DN=true;
           if (i== 1 && Alerts_on_close && DN_on_closeHTR_alert ) {DN_on_closeHTR_alert = false; Alert("Symbol "+Symbol()+" On close High Tail Reverse"); }
           }
        }
     
     //High Tail Continuation
     if (Tail_Continuation == 0 && Close[i+1]-Open[i+1] <0 && Close[i+2]-Open[i+2]<0 )
        { if((High[i+1]-Open[i+1]) > 0 ) 
            {
            dTail = (0); 
            UP=false; 
            DN=true;
            }
        }
     if (Tail_Continuation > 0 && Close[i+1]-Open[i+1] <0 && Close[i+2]-Open[i+2]<0 ) 
        { if((High[i+1]-Open[i+1]) > Tail_Continuation*Point) 
          {dTail = (High[i+1]+Range*Point); 
          UP=false; 
          DN=true;
          if (i== 1 && Alerts_on_close && DN_on_closeHTC_alert ) {DN_on_closeHTC_alert = false; Alert("Symbol "+Symbol()+" On close High Tail Continuation"); }
          }
       }
     
     
     //No tail
     if((High[i+1]-Open[i+1]) == 0 ) dTail = 0;
     if((Open[i+1]-Low[i+1]) == 0 ) dTail = 0;
     
      //double dTail=Tail[i];
      if(dTail>0)
        {
         if(UP==true) {
                        ExtTailsBuffer[i+1]=dTail;
                        ExtTailsUpBuffer[i+1]=dTail;
                        ExtTailsDownBuffer[i+1]=0.0;        
         }
         if(DN==true) {
                        ExtTailsBuffer[i+1]=dTail;
                        ExtTailsUpBuffer[i+1]=0.0;
                        ExtTailsDownBuffer[i+1]=dTail;        
         }
        }
      else
        {
         ExtTailsBuffer[i+1]=dTail;
         ExtTailsUpBuffer[i+1]=0.0;
         ExtTailsDownBuffer[i+1]=0.0;        
        }       
       
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////       
     }
     
     i=0;
     UP=false; DN=false;
     //Low Tail Reverse
     //double dTail;
     if (Tail_Reverse == 0) { 
                            if(Open[i]-Low[i] > 0 && Close[i]-Open[i] >0 && Open[i+1]-Close[i+1]>0 ) 
                              {
                              dTail = (Low[i+1]-Range*Point); UP=true; DN=false;
                              } else 
                                {
                                dTail = 0;
                                }

                            }
     if (Tail_Reverse > 0) {
                           if(Open[i]-Low[i] > Tail_Reverse*Point  && Close[i]-Open[i] >0 && Open[i+1]-Close[i+1]>0 ) 
                              {
                              dTail = (Low[i+1]-Range*Point); 
                              UP=true; 
                              DN=false;
                              if (Alerts_on_current && UP__on_currentLTR_alert ) {UP__on_currentLTR_alert = false; Alert("Symbol "+Symbol()+" On current Low Tail Reverse"); }
                              } 
                              else 
                              {
                              dTail = 0;
                              } 
                              } 
      
     //Low Tail Continuaion
     if (Tail_Continuation == 0 && Close[i]-Open[i] >0 && Close[i+1]-Open[i+1]>0 ) 
         { if(Open[i]-Low[i] > 0 ) 
           {dTail = (Open[i]-Low[i]); 
           UP=true; 
           DN=false;
           } 
           else {
           dTail = 0;
           }
         } 
     if (Tail_Continuation > 0 && Close[i]-Open[i] >0 && Close[i+1]-Open[i+1]>0 ) 
        { if(Open[i]-Low[i] > Tail_Continuation*Point ) 
          {
          dTail = (Low[i+1]-Range*Point); 
          UP=true; 
          DN=false;
          if (Alerts_on_current && UP__on_currentLTC_alert ) {UP__on_currentLTC_alert = false; Alert("Symbol "+Symbol()+" On current Low Tail Continuation"); }
          } 
          else 
          {
          dTail = 0;
          } 
        } 
     
     
     //High Tail Reverse
     if (Tail_Reverse == 0)
         { if((High[i]-Open[i]) > 0 && Close[i]-Open[i] <0 && Close[i+1]-Open[i+1]>0) 
            {
             dTail = (High[i]-Open[i]); 
             UP=false; 
             DN=true;
            }
         }
     if (Tail_Reverse > 0) 
        { if((High[i]-Open[i]) > Tail_Reverse*Point && Close[i]-Open[i] <0 && Close[i+1]-Open[i+1]>0) 
          {
          dTail = (High[i+1]+Range*Point);
          UP=false;
          DN=true;
          if (Alerts_on_current && DN_on_currentHTR_alert ) {DN_on_currentHTR_alert = false; Alert("Symbol "+Symbol()+" On current High Tail Reverse"); }
          }
        }
     
     //High Tail Continuation
     if (Tail_Continuation == 0 && Close[i]-Open[i] <0 && Close[i+1]-Open[i+1]<0 )
         { if((High[i]-Open[i]) > 0 ) 
           {
           dTail = (High[i]-Open[i]); 
           UP=false; 
           DN=true;}
           }
     if (Tail_Continuation > 0 && Close[i]-Open[i] <0 && Close[i+1]-Open[i+1]<0 ) 
        { if((High[i]-Open[i]) > Tail_Continuation*Point) 
           {
           dTail = (High[i+1]+Range*Point); 
           UP=false; 
           DN=true;
           if (Alerts_on_current && DN_on_currentHTC_alert ) {DN_on_currentHTC_alert = false; Alert("Symbol "+Symbol()+" On current High Tail Continuation"); }
           }
        }
     
     //No tail
     if((High[i]-Open[i]) == 0 ) dTail = 0;
     if((Open[i]-Low[i]) == 0 ) dTail = 0;
     
      //double dTail=Tail[i];
      if(dTail>0)
        {
         if(UP==true) {
                        ExtTailsBuffer[i]=dTail;
                        ExtTailsUpTmpBuffer[i]=dTail;
                        ExtTailsDownTmpBuffer[i]=0.0;        
         }
         if(DN==true) {
                        ExtTailsBuffer[i]=dTail;
                        ExtTailsUpTmpBuffer[i]=0.0;
                        ExtTailsDownTmpBuffer[i]=dTail;        
         }
        }
      else
        {
         ExtTailsBuffer[i]=dTail;
         ExtTailsUpTmpBuffer[i]=0.0;
         ExtTailsDownTmpBuffer[i]=0.0;        
        } 
         
             
//---- done
   return(0);
  }
//+------------------------------------------------------------------+


//////////////////////////////////////////////////////////////////<          >
bool       bNewBar ()                                           //<          >
{                                                               //<          >
//                                                              //<          >
static int iTime_0 = 0                                        ; //<          >
//                                                              //<          >
if       ( iTime_0 < iTime ( 0 , 0 , 0 ) )                      //<          >
         { iTime_0 = iTime ( 0 , 0 , 0 ) ; return ( TRUE  ) ; } //<          >
else     {                                 return ( FALSE ) ; } //<          >
//                                                              //<          >
}                                                               //<          >
//////////////////////////////////////////////////////////////////<          >


